"use strict";

exports.__esModule = true;
exports.default = _default;

var _babelPluginSyntaxPipelineOperator = _interopRequireDefault(require("babel-plugin-syntax-pipeline-operator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(_ref) {
  var t = _ref.types;
  return {
    inherits: _babelPluginSyntaxPipelineOperator.default,
    visitor: {
      BinaryExpression: function BinaryExpression(path) {
        var scope = path.scope;
        var node = path.node;
        var operator = node.operator,
            left = node.left;
        var right = node.right;
        if (operator !== "|>") return;
        var optimizeArrow = t.isArrowFunctionExpression(right) && t.isExpression(right.body);
        var param;

        if (optimizeArrow) {
          var _right = right,
              params = _right.params;

          if (params.length === 1) {
            param = params[0];
          } else if (params.length > 1) {
            optimizeArrow = false;
          }
        } else if (t.isIdentifier(right, {
          name: "eval"
        })) {
          right = t.sequenceExpression([t.numericLiteral(0), right]);
        }

        if (optimizeArrow && !param) {
          path.replaceWith(t.sequenceExpression([left, right.body]));
          return;
        }

        var placeholder = scope.generateUidIdentifierBasedOnNode(param || left);
        scope.push({
          id: placeholder
        });

        if (param) {
          path.get("right").scope.rename(param.name, placeholder.name);
        }

        var call = optimizeArrow ? right.body : t.callExpression(right, [placeholder]);
        path.replaceWith(t.sequenceExpression([t.assignmentExpression("=", placeholder, left), call]));
      }
    }
  };
}